Foreman - Refactor #25053

Run expensive db_facts query just once and unordered

09/27/2018 10:21 AM - Lukas Zapletal

Status: Closed
Priority: Normal
Assignee: Lukas Zapletal
Category: Facts
Target version:
Difficulty: Fixed in Releases: 1.20.0
Triaged: No Found in Releases:
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman/p
ull/6093,
https://github.com/theforeman/foreman/p
ull/6130
Description

It looks like this query is very expensive on MySQL: host.fact_values.where(:fact_name => fact_names.values).reorder(")

We call it twice currently while it is not needed to run this query twice, we can fetch the list of fact value IDs stored in database in
update step and prepare list of facts to be added in the next step in advance.

Also we order the query by ID for some reason, we can process them unordered just fine.

https://community.theforeman.org/t/foreman-1-18-2-fact-query-on-puppet-report-upload-fact-import-incredibly-slow/11238

Related issues:

Related to Foreman - Bug #25923: Puppet fact processing failed for hosts with... Closed

Associated revisions

Revision ce5bf100 - 10/10/2018 11:10 AM - Lukas Zapletal

Fixes #25053 - expensive db_facts query executed just once

Revision 37b9fata - 10/10/2018 01:52 PM - Tomer Brisker

Refs #25053 - Remove unused fact_names_by_id hash

History

#1 - 09/27/2018 10:25 AM - The Foreman Bot
- Status changed from New to Ready For Testing
- Pull request https://github.com/theforeman/foreman/pull/6093 added

#2 - 10/04/2018 02:16 PM - The Foreman Bot
- Pull request https://github.com/theforeman/foreman/pull/6108 added

#3 - 10/10/2018 11:21 AM - The Foreman Bot
- Pull request https://github.com/theforeman/foreman/pull/6130 added

#4 - 10/10/2018 11:24 AM - Tomer Brisker

- Pull request deleted (https://github.com/theforeman/foreman/pull/6108)

- Fixed in Releases 1.20.0 added

#5 - 10/10/2018 12:01 PM - Lukas Zapletal
- Status changed from Ready For Testing to Closed

Applied in changeset ce5bf100406c691769ba5dcbb55726b9386fe379.
https://community.theforeman.org/t/foreman-1-18-2-fact-query-on-puppet-report-upload-fact-import-incredibly-slow/11238
https://projects.theforeman.org/projects/foreman/repository/foreman/revisions/ce5bf100406c691769ba5dcbb55726b9386fe379

#6 - 01/27/2019 10:35 AM - Tomer Brisker
- Related to Bug #25923: Puppet fact processing failed for hosts with large number of LUNs attached added
